#language PascalScript
//16.04.2009 -  



// ************************************************************
function Decart_to_Polar_Coord(X,Y : extended; Var p,fi : extended) : boolean;
//   -  
begin
  Result:=false;
  p  := 0;
  fi := 0;
  if x<>0 then begin
     Result:=true;
     p  := sqrt(x*x+y*y);
     fi := arctan(y/x);
  end;
end;

procedure Polar_to_Decart_Coord(p,fi : extended; Var X,Y : extended);
//   -  
begin
  X := p*cos(fi);
  Y := p*sin(fi);
end;
// ************************************************************



// ************************************************************
function Decart_to_Cylindr_Coord(X,Y,Z : extended; Var p,fi,Zc : extended) : boolean;
//   -  
begin
  Result:=false;
  p  := 0;
  fi := 0;
  Zc := 0;
  if x<>0 then begin
     Result:=true;
     p  := sqrt(x*x+y*y);
     fi := arctan(y/x);
     Zc := Z;
  end;
end;

procedure Cylindr_to_Decart_Coord(p,fi,Zc : extended; Var X,Y,Z : extended);
//   -  
begin
  X := p*cos(fi);
  Y := p*sin(fi);
  Z := Zc;
end;
// ************************************************************



// ************************************************************
function Decart_to_Sphere_Coord(X,Y,Z : extended; Var r,fi,teta : extended) : boolean;
//   -  
begin
  Result:=false;
  r    :=0;
  fi   :=0;
  teta :=0;
  if x<>0 then begin
     if z<>0 then begin
        Result:=true;
        r    := sqrt(x*x+y*y+z*z);
        fi   := arctan(y/x);
        teta := arctan(sqrt(x*x+y*y)/z);
     end;
  end;
end;

procedure Sphere_to_Decart_Coord(r,fi,teta : extended; Var X,Y,Z : extended);
//   -  
begin
  X := r*sin(teta)*cos(fi);
  Y := r*sin(teta)*sin(fi);
  Z := r*cos(teta);
end;
// ************************************************************





// ************************************************************
function Cylindr_to_Sphere_Coord(p,fi,Z : extended; Var r,fi_s,teta : extended) : boolean;
//   -  
begin
  Result:=false;
  r     := 0;
  fi_s  := 0;
  teta  := 0;
  if Z<>0 then begin
     Result:=true;
     r     := sqrt(p*p+z*z);
     fi_s  := fi;
     teta  := arctan(p/Z);
  end;
end;

procedure Sphere_to_Cylindr_Coord(r,fi,teta : extended; Var p,fi_c,Z : extended);
//   -  
begin
  p    := r*sin(teta);
  fi_c := fi;
  Z    := r*cos(teta);
end;
// ************************************************************




Var
 X,Y,Z, Zc : extended;
 p,r,fi,teta : extended;

BEGIN

  Msg_ClearAll;

  X:=2;
  Y:=1;

  Decart_to_Polar_Coord(X,Y,p,fi);
  MSG_Writeln('X='+FloatToStr(X)+';  Y='+FloatToStr(Y)+'  ->  '+'p='+FloatToStr(p)+';  fi='+FloatToStr(fi));
  Polar_to_Decart_Coord(p,fi,X,Y);
  MSG_Writeln('p='+FloatToStr(p)+';  fi='+FloatToStr(fi)+'  ->  '+'X='+FloatToStr(X)+';  Y='+FloatToStr(Y));


  MSG_Writeln('');
  MSG_Writeln('');


  X:=2;
  Y:=1;
  Z:=3;

  Decart_to_Cylindr_Coord(X,Y,Z,p,fi,Zc);
  MSG_Writeln('X='+FloatToStr(X)+';  Y='+FloatToStr(Y)+';  Z='+FloatToStr(Z)+'  ->  '+'p='+FloatToStr(p)+';  fi='+FloatToStr(fi)+';  Z='+FloatToStr(Zc));
  Cylindr_to_Decart_Coord(p,fi,Zc,X,Y,Z);
  MSG_Writeln('p='+FloatToStr(p)+';  fi='+FloatToStr(fi)+';  Z='+FloatToStr(Zc)+'  ->  '+'X='+FloatToStr(X)+';  Y='+FloatToStr(Y)+';  Z='+FloatToStr(Z));


  MSG_Writeln('');
  MSG_Writeln('');



  X:=2;
  Y:=1;
  Z:=3;

  Decart_to_Sphere_Coord(X,Y,Z,p,fi,teta);
  MSG_Writeln('X='+FloatToStr(X)+';  Y='+FloatToStr(Y)+';  Z='+FloatToStr(Z)+'  ->  '+'p='+FloatToStr(p)+';  fi='+FloatToStr(fi)+';  teta='+FloatToStr(teta));
  Sphere_to_Decart_Coord(p,fi,teta,X,Y,Z);
  MSG_Writeln('p='+FloatToStr(p)+';  fi='+FloatToStr(fi)+';  teta='+FloatToStr(teta)+'  ->  '+'X='+FloatToStr(X)+';  Y='+FloatToStr(Y)+';  Z='+FloatToStr(Z));




  MSG_Writeln('');
  MSG_Writeln('');

  X:=2;
  Y:=1;
  Z:=3;

  MSG_Writeln('BEFORE: X='+FloatToStr(X)+';  Y='+FloatToStr(Y)+';  Z='+FloatToStr(Z));
  Decart_to_Sphere_Coord(X,Y,Z,r,fi,teta);
  Sphere_to_Cylindr_Coord(r,fi,teta, p,fi,Z);
  Cylindr_to_Sphere_Coord(p,fi,Z, r,fi,teta);
  Sphere_to_Decart_Coord(r,fi,teta,X,Y,Z);
  MSG_Writeln('AFTER : X='+FloatToStr(X)+';  Y='+FloatToStr(Y)+';  Z='+FloatToStr(Z));


END.

